--Testing for the old Model
--This testing suite has been CRIPPLED in order to be executable, start over from the proposed model!


note
	description : "testSCOOP application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		local
			i, max: INTEGER
			last_percentage, now_percentage: REAL_64
			stop: BOOLEAN
			start_t, end_t: TIME
		do

			create start_t.make_now

			from
				i := 0
				max := (12).power(max_calls).floor
				print ("%N%N%NTotal of experiments: " + max.out + "%N")
			until
				i >= max or stop
			loop

				last_percentage := (i-1) / (max / 100)
            	now_percentage := (i) / (max / 100)
            	if last_percentage.floor /= now_percentage.floor then
            		print("%R" + now_percentage.floor.out + "%% done.")
            	end

            	stop := execute_whole_job(i)

            	i := i+1
			end
			print ("%R100%% done.%N")

			create end_t.make_now
			print ("Fine seconds elapsed: " + (end_t.fine_seconds - start_t.fine_seconds).out + "%N")
		end

	execute_whole_job (i: INTEGER): BOOLEAN
		local
			p, q: separate WORKER
			stop: BOOLEAN
		do
			if not stop then

				print_debug ("Debug: Whole Job " + i.out + "%N")
				create p.make
				create q.make
				p_flag := False
				q_flag := False

				execute_whole_job_internal(p, q, i)
				Result := False
			end
		rescue
			print ("Reached Max. SCOOP Processors. Last job was: " + i.out + "%N")
			stop := True
			Result := True
			retry
		end

	--This is used so the locks on P and Q are never released! (Does not matter for old system)
	execute_whole_job_internal(p, q: separate WORKER; i: INTEGER)
		local
			job, job_total, step: INTEGER
		do

			from
				job_total := i
				step := 1
			until
				job_total = 0
			loop
				job := job_total \\ 12

				print_debug ("Debug: Executing job: " + (job+1).out + "%N")
				execute_job(job+1, p, q)

				job_total := (job_total - job) // 12
				step := step+1
			end

		end

	execute_job (job: INTEGER; p, q: separate WORKER)
		local
			b, stop: BOOLEAN
		do
			if stop then
				--The job can't be accomplished (such as a failing sync call), and has thrown the expected exception.
				--Therefor, move on
			else
				inspect
				        job
				when 1 then
					print_debug ("Debug: Executing job 1: Send async call p -> q%N")
					b := p.send_async_call (q)
				when 2 then
					print_debug ("Debug: Executing job 2: Send async call p -> q and FAIL. Setting Q dirty.%N")
					b := p.send_async_call_fail (q)
				when 3 then
					print_debug ("Debug: Executing job 3: Send sync call p -> q%N")
					b := p.send_sync_call (q)
				when 4 then
					print_debug ("Debug: Executing job 4: Send sync call p -> q and FAIL%N")
					b := p.send_sync_call_fail (q)
				when 5 then
					print_debug ("Debug: Executing job 5: Send self call p -> p%N")
					b := p.send_self_call
				when 6 then
					print_debug ("Debug: Executing job 6: Send self call p -> p and FAIL%N")
					b := p.send_self_call_fail
				when 7 then
					print_debug ("Debug: Executing job 7: Send async call q -> p%N")
					b := q.send_async_call (p)
				when 8 then
					print_debug ("Debug: Executing job 8: Send async call q -> p and FAIL. Setting P dirty.%N")
					b := q.send_async_call_fail (p)
				when 9 then
					print_debug ("Debug: Executing job 9: Send sync call q -> p%N")
					b := q.send_sync_call (p)
				when 10 then
					print_debug ("Debug: Executing job 10: Send sync call q -> p and FAIL%N")
					b := q.send_sync_call_fail (p)
				when 11 then
					print_debug ("Debug: Executing job 11: Send self call q -> q%N")
					b := q.send_self_call
				when 12 then
					print_debug ("Debug: Executing job 12: Send self call q -> q and FAIL%N")
					b := q.send_self_call_fail
				end

			end
		rescue
			print_debug ("Debug: In rescue of APPLICATION.execute_job%N")

			stop := True
			retry

		end

	max_calls: INTEGER = 4
	p_flag, q_flag: BOOLEAN

	debug_on: BOOLEAN = False

	print_debug (s: STRING)
		do
			if debug_on then
				print(s)
			end
		end

	my_exception: DEVELOPER_EXCEPTION
            once
                create Result
            end

end
