--FAIL: Due to the way the DFR is implemented, the processor nudging it will receive the exception this might cause.
--		In other words, the processor that wanted the file "a" to be read will receive the exception generaed from file "x" being unreadable!
--SOLUTION: Implement an ANSWER_REGISTER, which is fed through the DFR. Workers feed/nudge the DFR, but then query the AR.
--			AR then manually generates exceptions when necessary, leaving the burden of exceptions with the developer.
--DIFFERENT SOLUTION: DFR would not have one workload, but one for each WORKER. WORKERs would only nudge their own workload, thus only creating exceptions for themseles.
--					  While a nice system in theory, this is too hairy to actually consider...


note
	description : "readfile_improved_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w: separate WORKER
			dfr: separate DEDICATED_FILE_READER
			ans: separate ANSWER_REGISTER
			i: INTEGER
		do
			create ans.make
			create dfr.make (ans)

			--print ("Now creating WORKERs.%N")

			from
				i := 1
			until
				i > 2
			loop
				create w.make (i, dfr, ans)
				start (w)
				i := i+1
			end
		end

	start (w: separate WORKER)
		do
			w.live
		end

end
