--FAIL: Due to the safemode, the nudging of the WORKERs actually causes them to pause until an IO Request has been served.
--		So there is always exactly one WORKER stuck waiting, while all otherswait for the lock itself!
--		To make matters worse, nudging might lead to exceptions completely unrelated to the WORKER. On other words, the same thing as with the old system happens:
--		The wrong WORKER receives the wrong exception!
--FAIL: Starting multiple long-lived workers...
--SOLUTION: With the implementation of the answer register, there no longer is an exceptions when actually reading files, so the problem is mitigated.
--			However, there are still all WORKERs pretty much always stuck, which is bad.
--SOLUTION: For the multiple WORKERs, hack


note
	description : "readfile_improved_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w1, w2: separate WORKER
			dfr: separate DEDICATED_FILE_READER
			ans: separate ANSWER_REGISTER
		do
			create ans.make
			create dfr.make (ans)

			create w1.make (1, dfr, ans)
			create w2.make (2, dfr, ans)

			start (w1, w2)
		end

	start (w1, w2: separate WORKER)
		do
			w1.live
			w2.live
		end

end
