note
	description: "Summary description for {DEDICATED_FILE_READER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	DEDICATED_FILE_READER

create
	make

feature

	make (a: separate ANSWER_REGISTER)
		do
			create workload.make
			ans := a
		end

	queue_file (file_name: separate STRING)
		local
			already_queued: BOOLEAN
			s: STRING
		do
			create s.make_from_separate ( file_name )
			--print ("DFR: Queueing of File " + s + " requested...%N")

			already_queued := is_queued (s)

			if not already_queued then
				workload.put_left (s)
				--print ("DFR: File " + s + " has been queued.%N")
			else
				--print ("DFR: File " + s + " was already queued.%N")
			end
		rescue
			--print ("DFR: In rescue of queue_file%N")
		end

	is_queued (s: STRING): BOOLEAN
		do
			from
				workload.start
			until
				workload.after
			loop
				if workload.item.is_equal (s) then
					Result := True
					workload.finish
				end
				workload.forth
			end
		rescue
			--print ("DFR: In rescue of is_queued%N")
		end

	read_file
		local
			file_name, line: STRING
			input : PLAIN_TEXT_FILE
	    do
	    	if workload.is_empty then
	    		--No work
	    	else
				file_name := workload.first

		    	--print ("DFR: Reading file " + file_name + " now...%N")

			    create input.make_open_read(file_name)
			    input.read_line
			    line := input.last_string
			    input.close

			    --print ("DFR: The file " + file_name + " was successfully read.%N")

				put_answer (ans, line, file_name)

				workload.start
				workload.remove
	    	end
	    rescue
	    	--print ("DFR: The file " + file_name + " could NOT be read.%N")

	    	put_answer (ans, "ERROR", file_name)

			workload.start
			workload.remove
		end

	put_answer (a: separate ANSWER_REGISTER; line, file_name: STRING)
		do
			a.put_answer (line, file_name)
		rescue
			--print ("DFR: In rescue of put_answer%N")
		end

feature {NONE}

workload: LINKED_LIST[STRING]
ans: separate ANSWER_REGISTER

end
