note
	description: "Summary description for {DEDICATED_FILE_READER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	DEDICATED_FILE_READER

create
	make

feature

	make (a: separate ANSWER_REGISTER; b: separate BOUNDED_BUFFER[INTEGER])
		do
			create workload.make
			ans := a
			bb := b
		end

	live
		do
			from

			until
				stop > 50
			loop
				get_work (bb)
				read_file
			end
			--print ("DFR: Stopping, noone seems to be producing into the buffer.%N")
		rescue
			--print ("DFR: Uh oh... live%N")
			retry
		end

	get_work (b: separate BOUNDED_BUFFER[INTEGER])
		local
			i: INTEGER
			already_queued: BOOLEAN
		do
			if not b.is_empty then
				--print ("DFR: Trying to get work.%N")
				i := b.consume
				--print ("DFR: Gotten work.%N")
				stop := 0
				already_queued := is_queued (i.out)
				if not already_queued then
					workload.put_left (i.out)
				end
			else
				stop := stop+1
			end
		rescue
			print ("DFR: Could not consume from Bounded Buffer. This deadlocks the system.%N")
			stop := stop + 1
		end

	is_queued (str: STRING): BOOLEAN
		do
			from
				workload.start
			until
				workload.after
			loop
				if workload.item.is_equal (str) then
					Result := True
					workload.finish
				end
				workload.forth
			end
		rescue
			--print ("DFR: Uh oh... is_queued%N")
		end

	read_file
		local
			file_name, line: STRING
			input : PLAIN_TEXT_FILE
	    do
	    	if workload.is_empty then
	    		--No work
	    	else
				file_name := workload.first

		    	--print ("DFR: Reading file " + file_name + " now...%N")

			    create input.make_open_read(file_name)
			    input.read_line
			    line := input.last_string
			    input.close

			    --print ("DFR: The file " + file_name + " was successfully read.%N")

				put_answer (ans, line, file_name)

				workload.start
				workload.remove
	    	end
	    rescue
	    	--print ("DFR: The file " + file_name + " could NOT be read.%N")

	    	put_answer (ans, "ERROR", file_name)

			workload.start
			workload.remove
		end

	put_answer (a: separate ANSWER_REGISTER; line, file_name: STRING)
		do
			a.put_answer (line, file_name)
		rescue
			--print ("DFR: Uh oh... put_answer%N")
		end

feature {NONE}

workload: LINKED_LIST[STRING]
ans: separate ANSWER_REGISTER
bb: separate BOUNDED_BUFFER[INTEGER]
stop: INTEGER

end
