note
	description: "Summary description for {WORKER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WORKER

create
	make

feature

	make (i: INTEGER; b: separate BOUNDED_BUFFER[INTEGER]; a: separate ANSWER_REGISTER)
		do
			number := i
			ans := a
			bb := b
		end

	live
		local
			end_t: TIME
		do
			from

			until
				counter > 10000
			loop
				if not waiting then
					queue_file (bb)
				end
				get_results (ans)
			end

			create end_t.make_now
			print ("Fine seconds at the end of worker: " + end_t.fine_seconds.out + "%N")
		rescue
			retry	--Ah, the good old on error continue ;)
		end

	queue_file (b: separate BOUNDED_BUFFER[INTEGER])
		require
			buffer_not_full: not b.is_full
		do
			b.put (number * 1000000 + counter)
		rescue
			print ("WORKER " + number.out + ": Could not produce into Bounded Buffer. This deadlocks the system.%N")
		end

	get_results (a: separate ANSWER_REGISTER)
		local
			res: STRING
		do
			create res.make_from_separate (a.get_results ((number * 1000000 + counter).out))
			if res.count > 0 and then res.is_equal ("ERROR") then
				--print ("WORKER Encountered exception getting result. Seems like file was not readable ;(%N")
				waiting := False
				counter := counter + 1
			elseif res.count > 0 then
				waiting := False
				counter := counter + 1
				--print ("WORKER " + number.out + ": Result: " + res + "%N")
			else
				waiting := True
				--print ("WORKER " + number.out + ": Result: None, waiting.%N")
			end
		rescue
			print ("WORKER " + number.out + ": Encountered exception. This deadlocks the system.%N")
			waiting := False
			counter := counter + 1
		end

feature {NONE}

	number: INTEGER
	ans: separate ANSWER_REGISTER
	bb: separate BOUNDED_BUFFER[INTEGER]
	waiting: BOOLEAN
	counter: INTEGER

end
