--FAIL: Can't deal with long-lived entities
--SOLUTION: Hack


note
	description	: "System's root class"
	author		: "Volkan Arslan, Yann Mueller, Piotr Nienaltowski."
	date		: "$Date: 18.05.2007$"
	revision	: "1.0.0"

class
	PRODUCER_CONSUMER

create
	make

feature -- Initialization

	make
			-- Create and launch separate objects.
		local
			p1, p2: separate PRODUCER
			c1, c2, c3: separate CONSUMER
		do
			create buffer.make_with_capacity (buffer_capacity)

			create p1.make_with_buffer (buffer, 1)
			create p2.make_with_buffer (buffer, 2)
			create c1.make_with_buffer (buffer, 1)
			create c2.make_with_buffer (buffer, 2)
			create c3.make_with_buffer (buffer, 3)

			launch_all (p1, p2, c1, c2, c3)

		end

feature {NONE} -- Implementation

	buffer: separate BOUNDED_BUFFER [INTEGER]
			-- Shared product buffer.

	launch_all (p1, p2: separate PRODUCER; c1, c2, c3: separate CONSUMER)
			-- Launch `a_producer'.
		do
			p1.produce (items_per_producer)
			p2.produce (items_per_producer)
			c1.consume (items_per_consumer)
			c2.consume (items_per_consumer)
			c3.consume (items_per_consumer)
		end


	buffer_capacity: INTEGER = 2
			-- Buffer capacity.

	items_per_producer: INTEGER = 300
			-- Production count per producer.

	items_per_consumer: INTEGER = 200
			-- Consumption per consumer.

end -- class PRODUCER_CONSUMER

