note
	description : "sandbox application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

create
	make

feature {NONE} -- Initialization

	make
			-- Places async call
			-- No exceptions locally
			-- No exceptiosn propagated
			-- Gets/releases lock with each call
		local
			w: separate WORKER
			i: INTEGER
		do
			create w.make

			do_work_async (w)

			do_work_sync (w)

			from
				i := 1
			until
				i > repeat
			loop
				if i \\ step = 0 then
					print (i.out + "/" + repeat.out + "%N")
				end

				do_work_lock_unlock (w)							--Safemode

				i := i + 1
			end
		end

	do_work_async (w: separate WORKER)
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > repeat
			loop
				if i \\ step = 0 then
					print (i.out + "/" + repeat.out + "%N")
				end

				w.do_nothing

				i := i + 1
			end
		end

	do_work_sync (w: separate WORKER)
		local
			i: INTEGER
			b: BOOLEAN
		do
			from
				i := 1
			until
				i > repeat
			loop
				if i \\ step = 0 then
					print (i.out + "/" + repeat.out + "%N")
				end

				b := w.return_true

				i := i + 1
			end
		end

	do_work_lock_unlock (w: separate WORKER)
		local
			b: BOOLEAN
		do
				b := w.return_true	--Some light workload, this ensures we only measure the true unlocking time.
		end

	repeat: INTEGER = 100000
	step: INTEGER = 10000
	repeat_small: INTEGER = 1000
	step_small: INTEGER = 100
end
